;====================================================================
; Main.asm file generated by New Project wizard
;
; Created:   Thu Jan 5 2017
; Processor: PIC12F675
; Compiler:  MPASM (MPLAB)
;====================================================================

            list p=12F675, b=8, c= 120, n=71, t=on, st=off, f=inhx32
            #include    <p12f675.inc>
            errorlevel	-302
            radix dec
            #define     BUFLEN 6
            CBLOCK      0x22            ; first 2 bytes assigned for macro.inc
            buffer:BUFLEN
            RXCHAR, FSRTMP, PTRL, PTRH, ticks, x, i, flags
            F_ISR, P_ISR, W_TEMP, STATUS_TEMP, GPIO_shadow, CHARCNT, GPIOcopy
            RD_PTR, WR_PTR, Reg4W
            ENDC

            __CONFIG _WDT_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF

            #define     timer_state0 flags,0
            #define     timer_state1 flags,1
            #define     TXFLAG flags,2  
            #define     PORT0 flags,3
            #define     PORT1 flags,4
            #define     zeroX flags,5
            #define     TICKSVAL 2
            #define     dec_no Reg4W
; interrupt on timer1 will occur every half second
; corrections may be required
            #define     settmr1H  11    ; preset for timer1 MSB register
            #define     settmr1L  220   ; preset for timer1 LSB register
            #define     TXPIN 0
            #define     OUT1PIN 1
            #define     RXPIN 2
            #define     IN1PIN 3
            #define     OUT0PIN 4
            #define     IN0PIN 5
            #define     IN0 GPIO,IN0PIN
            #define     IN1 GPIO,IN1PIN
            #define     TXD GPIO,TXPIN
            #define     RXD GPIO,RXPIN
;           DEFINE to allow to operate with an encoder as input
            #define     ENCODER 1

_Print      macro       str
            local       String, Print
            movlw       low String
            movwf       PTRL
            movlw       high String
            movwf       PTRH
            goto        Print
String      dt          str,0
Print       call        PutString       ; print string
            endm

            org         0x0000
            goto        Main
            org         0x0004
;==============================================================================
;                    Interrupt Service Routine
;==============================================================================

            movwf       W_TEMP          ; save W-reg
            swapf       STATUS,W        ; doesn't change STATUS bits
            movwf       STATUS_TEMP     ; save STATUS reg
            clrf        STATUS          ; bank 0
            movf        PCLATH,W        ; get PCLATH
            movwf       P_ISR           ; save PCLATH
            movf        FSR,W           ; get FSR
            movwf       F_ISR           ; save FSR

            btfss       INTCON,T0IE     ; timer0 interrupt enabled?
            goto        ckExInt         ; no, check something else
            btfsc       INTCON,T0IF     ; timer0 interrupt?
            goto        ISR_SET         ; yes, check what's to move
ckExInt     btfss       INTCON,INTF     ; RXD "start bit" interrupt?
            goto        ISR_NXT         ; no, branch
            bcf         INTCON,INTE     ; start reception and stop interrupts
            bcf         INTCON,INTF     ; clear external interrupt flag
            bcf         TXFLAG          ; indicate RX in progress
            movlw       10              ; (1 start + 8 data + 1 stop)
            movwf       CHARCNT         ; initialize RX bit counter
            bcf         INTCON,T0IF     ; clear TMR0 interrupt flag
            movlw       -51             ; 1/2 bit time
            movwf       TMR0
            bsf         INTCON,T0IE     ; start the timer0
            goto        ISR_NXT         ; wait next timer0 interrupt
ISR_SET     bcf         INTCON,T0IF     ; clear TMR0 interrupt flag
            movlw       -103            ; setup for next int
            movwf       TMR0
            btfsc       TXFLAG          ; TX in progress?
            goto        ISR_TX          ; no, branch
ISR_RX      movf        WR_PTR,W        ; get WR_PTR (RXBUFF + 00..07)
            movwf       FSR             ; setup indirect address
            clrc                        ; clear Carry, assume data = 0
            btfsc       RXD             ; TRPIN = 0 ?
            setc                        ; no, set Carry, data = 1
            rrf         INDF,F          ; shift bit into our character
            decfsz      CHARCNT,F       ; all 10 bits?
            goto        ISR_NXT         ; no, branch
            rlf         INDF,F          ; yes, get rid of the stop bit
            incf        WR_PTR,W        ; W = WR_PTR + 1
            sublw       buffer+BUFLEN   ; this works for 20..27
            xorwf       RD_PTR,W        ; WR_PTR+1 = RD_PTR (full)?
            skpz                        ; yes, ignore new character
            incf        WR_PTR,F
            bcf         WR_PTR,3
            goto        END_TX
ISR_TX      movf        CHARCNT,W       ; get TX bit count
            bnz         ISR_TX0         ; no, branch, send next bit
            movlw       10              ; 10 bits (start + 8 data + st
            movwf       CHARCNT         ; initialize TX bit counter
            goto        ISR_TX1         ; send the start bit
ISR_TX0     rrf         RXCHAR,F        ; shift lsb into C
            bsf         RXCHAR,7        ; set bit 7 for stop bits
            skpnc                       ; skip if C=0
            bsf         TXD             ; set TX pin
            skpc                        ; skip if C=1
ISR_TX1     bcf         TXD             ; clr TX pin
            decfsz      CHARCNT,F       ; last bit shifted out?
            goto        ISR_NXT
END_TX      bcf         TXFLAG          ; yes, indicate end of TX
            bcf         INTCON,T0IE     ; stop timer0, transmission ended
            bsf         INTCON,INTE     ; permit reception
ISR_NXT
            banksel     PIR1            ; select bank 0
            btfss       PIR1,TMR1IF     ; If TMR1IF is set Then
            goto        ISR_XIT         ; no, then return
            call        reloadTMR1      ; reload the Timer1
            bcf         PIR1,TMR1IF     ; PIR1.TMR1IF = 0
            decfsz      ticks,F         ; if ticks zero
            goto        ISR_XIT         ; no, see for the next
            bsf         zeroX           ; signalize reached zero count
            movlw       TICKSVAL        ; reload ticks
            movwf       ticks
ISR_XIT     movf        F_ISR,W
            movwf       FSR             ; restore FSR
            movf        P_ISR,W
            movwf       PCLATH          ; restore PCLATH
            swapf       STATUS_TEMP,W
            movwf       STATUS          ; restore STATUS
            swapf       W_TEMP,F        ; don't screw up STATUS
            swapf       W_TEMP,W        ; restore W-reg
            retfie                      ; return from interrupt

Put232      btfsc       TXFLAG          ; busy?
            goto        Put232          ; yes, branch and wait
            bsf         INTCON,T0IE     ; start timer0, new transmission
            bcf         INTCON,INTE     ; stop external interrupts
            movwf       RXCHAR          ; stuff character
            bsf         TXFLAG          ; initiate TX
            return

Get232      movf        RD_PTR,W
            xorwf       WR_PTR,W        ; RD_PTR = WR_PTR (buff empty)?
            skpnz
            return
            movf        FSR,W           ; get and save FSR
            movwf       FSRTMP
            movf        RD_PTR,W
            movwf       FSR             ; setup indirect address
            movf        INDF,W          ; get RXBUFF[RD_PTR] character
            movwf       RXCHAR          ; save it for later
            movf        FSRTMP,W
            movwf       FSR             ; restore FSR
            incf        RD_PTR,W        ; increment RD_PTR
            andlw       b'00100111'     ; keep it in range 20..27
            movwf       RD_PTR
            movf        RXCHAR,W        ; get receive character
            return

;==============================================================================
;                       initialization
;==============================================================================

init        call        0x3FF           ; load calibration bits
            banksel OSCCAL              ; select the correct bank
            movwf       OSCCAL          ; save them
            clrf        flags           ; clear all flags
            clrf        CHARCNT         ; init CHARCNT variable
            movlw       1<<RXPIN | 1<<IN0PIN | 1<<IN1PIN
            movwf       TRISIO
            movwf       WPU
            movlw       b'00000010'     ; prescaler 1:8, 1200 baud
            movwf       OPTION_REG
            ; setting timer0, general and port interrupts
            movlw       1<<GIE | 1<<GPIE | 1<<PEIE | 1<<INTE
            movwf       INTCON
            clrf        ANSEL
            clrf        VRCON           ; VRCON = 0
            banksel GPIO
            bsf         TXD             ; put TXPIN in idle state
            movlw       b'00110001'     ; Timer1 enabled prescaler 1:8
            movwf       T1CON
            movlw       7               ; comparators off
            movwf       CMCON
            movlw       TICKSVAL        ; reload ticks
            movwf       ticks
reloadTMR1  
            banksel TMR1H               ; reset to right bank if recalled
            movlw       settmr1H        ; set for timer1H MSB register
            movwf       TMR1H
            movlw       settmr1L        ; set for timer1L LSB register
            movwf       TMR1L
            return                      ; return

PutString
            call        GetTable        ; get a table character
            andlw       b'11111111'
            skpnz                       ; 00 byte, last character?
            return                      ; yes, return
            call        Put232          ; else,output character
            incfsz      PTRL,F          ; increment pointer
            goto        PutString
            incf        PTRH,F
            goto        PutString
GetTable
            movf        PTRH,W
            movwf       PCLATH
            movf        PTRL,W
            movwf       PCL

Main        call        init
            banksel     PIE1
            bsf         PIE1,TMR1IE
resume      movlw       buffer          ; RX circular buffer address
            movwf       RD_PTR          ; init circular buffer RD ptr
            movwf       WR_PTR          ; init circular buffer WR ptr
main_loop   _Print  "System ready\r\n"
Loop        btfss       zeroX
            goto        next
            banksel     GPIO
            bcf         zeroX
            btfss       flags,6
            goto        flip
            bcf         flags,6
            bcf         GPIO,OUT0PIN
            goto        next
flip        bsf         flags,6
            bsf         GPIO,OUT0PIN
next        call        Get232          ; receive character
            bz          Loop
            clrf        CHARCNT
put_new     call        Put232          ; echo character back
            goto        Loop            ; loop forever

            end
